#include	<windows.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include 	<sys\timeb.h>
#include 	<time.h>
#include	<conio.h>
#include	<fcntl.h>
#include	<io.h>
#include	<sys/stat.h>
#include	"type.h"
#include	"pio.h"

//#define AGB_DEBUG

#define PC_RDONLY		0x0001	//ǂݍݐp
#define PC_WRONLY		0x0002	//ݐp
#define PC_RDWR			0x0003	//ǂݏ
#define PC_APPEND		0x0100	//ǉ
#define PC_CREAT		0x0200	//t@C쐬
#define PC_TRUNC		0x0400	//t@C̒Oɂ

#define PC_SEEK_SET		0		//t@C̐擪
#define PC_SEEK_CUR		1		//݂̃t@C|Cg
#define PC_SEEK_END		2		//t@C̍Ōォ

#define FW_ACK					0x12345678
#define	CMD_ROM_PROBE			0xffff0001	//
#define	CMD_WRAM_LOADEXEC		0xffff0002	//len
#define	CMD_ROM_BERASE			0xffff0003	//add
#define	CMD_ROM_WRITE			0xffff0004	//add,len
#define CMD_ROM_BWRITE			0xffff0005	//addw,lenw
#define CMD_READ				0xffff0006	//add,len
#define CMD_READ2				0xffff0012	//add,len (ULTRA)
#define CMD_WRITE				0xffff0007	//add,len
#define	CMD_FIND				0xffff0008	//add,len,strlen
#define CMD_BOOT_ROM			0xffff0009	//
#define	CMD_SRAM2EWRAM			0xffff000a	//bank    ERAM:0x02000000
#define	CMD_EWRAM2SRAM			0xffff000b	//bank    ERAM:0x02000000
#define	CMD_BU_PROBE			0xffff000c	//ret 0:none 1:SRAM256K 2:SRAM512K 3:FLASH512 4:EEP4K 5:EEP64K 6:FLASH1M 7:FLASH8M
#define CMD_SRAM_READ			0xffff000d	//ofs,len
#define CMD_EEP_READ			0xffff000e	//ofs,len
#define CMD_EEP_WRITE			0xffff000f	//ofs,len
#define CMD_SRAM_WRITE			0xffff0010	//ofs,len
#define CMD_FLASH_WRITE			0xffff0011	//ofs,len
#define CMD_BLANK				0xffff0020	//
#define CMD_IS_PRO				0xffff0021	//

void crc32_init();
u32 crc32_calc(u8 *buf,u32 len);

u32 buf[1024*1024/4];

u16 base;
u32 is_pro;

//base+1(input)
#define	_GBSTB		0x80
	
//base+2(output)
#define	PCSTB_ON	0x00
#define	PCSTB_OFF	0x01
#define	DIR_ON		0x04
#define	DIR_OFF		0x00

write_4bit(u8 m){
	outport(base+0,m);
	outport(base+2,DIR_OFF|PCSTB_ON);
	for(;;){
		if((inport(base+1) & _GBSTB)==0) break;
	}
	outport(base+2,DIR_OFF|PCSTB_OFF);
}

write_32bit(u32 m){
	s32 i;
	for(i=0;i<8;i++){
		outport(base+0,(u8)(m>>(28-4*i)));
		outport(base+2,DIR_OFF|PCSTB_ON);
		for(;;){
			if((inport(base+1) & _GBSTB)==0) break;	//GSTB==1
		}
		outport(base+2,DIR_OFF|PCSTB_OFF);
	}
	for(;;){
		if(inport(base+1) & _GBSTB) break;			//GSTB==0
	}
}

u8 read_4bit(){
	u8 m;
	outport(base+2,DIR_ON|PCSTB_OFF);
	for(;;){
		if((inport(base+1) & _GBSTB)==0) break;		//GSTB==1
	}

	m=(inport(base+1) >> 3) & 0x0f;
	outport(base+2,DIR_OFF|PCSTB_ON);
	for(;;){
		if(inport(base+1) & _GBSTB) break;			//GSTB==0
	}
	outport(base+2,DIR_OFF|PCSTB_OFF);
	return(m);
}

u32 read_32bit(){
	s32 i;
	u32 m;
	for(i=m=0;i<8;i++){
		m+=read_4bit() << (4*i);
	}
	return(m);
}

void port_change(){
	if(base==0x278) base=0x378;
	else if(base==0x378) base=0x3bc;
	else base=0x278;
}

void dev_init(){
	s32 i;
	HANDLE h;
	h = CreateFile("\\\\.\\giveio", GENERIC_READ, 0, NULL,
					OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if(h != INVALID_HANDLE_VALUE) {
		CloseHandle(h);
	}
	base=0x378;
	for(;;){
		outport(base+2,DIR_OFF|PCSTB_OFF);
		outport(base+0,0x05);
		for(i=0;i<100;i++){
			if(((inport(base+1) >> 3) & 0x0f)==0x05) break;
		}
		if(i==100){
			port_change();
			continue;
		}
		outport(base+0,0x0a);
		for(i=0;i<100;i++){
			if(((inport(base+1) >> 3) & 0x0f)==0x0a) break;
		}
		if(i==100){
			port_change();
			continue;
		}
		outport(base+0,0x05);
		for(i=0;i<100;i++){
			if(((inport(base+1) >> 3) & 0x0f)==0x05) break;
		}
		if(i==100){
			port_change();
			continue;
		}
		break;
	}
}

void host_proc(){
	s32 fh;
	u32 i;
	u32 cmd,len,flag,where;
	s8 s[256];
	for(;;){
		cmd=read_32bit();
		switch(cmd){
		case 0xf0f0f001://open
			len=read_32bit();
			for(i=0;i<len;i++){
				*((u32 *)(s+4*i))=read_32bit();
			}
			len=read_32bit();
			for(i=0;i<strlen(s);i++){
				if(s[i]=='/') s[i]='\\';
			}
			if((len & 3)==PC_RDONLY){
				flag=O_RDONLY;
			}
			else if((len & 3)==PC_WRONLY){
				flag=O_WRONLY;
			}
			else{
				flag=O_RDWR;
			}
			if(len & PC_APPEND){
				flag |= O_APPEND;
			}
			if(len & PC_CREAT){
				flag |= O_CREAT;
			}
			if(len & PC_TRUNC){
				flag |= O_TRUNC;
			}
			fh=(u32)open(s,O_BINARY | flag,_S_IREAD | _S_IWRITE);
			write_32bit((u32)fh);
			break;
		case 0xf0f0f002://close
			fh=read_32bit();
			close(fh);
			break;
	    case 0xf0f0f003://read(pre)
	    	fh=read_32bit();
	    	len=read_32bit();
			len=read(fh,buf,len);
			write_32bit(len);
			for(i=0;i<(len+3)/4;i++){
				write_32bit(buf[i]);
			}
			break;
		case 0xf0f0f004://write
			fh=read_32bit();
			len=read_32bit();
	    	for(i=0;i<(len+3)/4;i++){
				buf[i]=read_32bit();
			}
			write(fh,buf,len);
			break;
		case 0xf0f0f005://lseek
			fh=read_32bit();
			len=read_32bit();
			where=read_32bit();
			len=lseek(fh,len,where);
			write_32bit(len);
			break;
		case 0xf0f0f000://PcPrintf()
			len=read_32bit();
			for(i=0;i<len;i++){
				*((u32 *)(s+4*i))=read_32bit();
			}
			printf("%s",s);
			break;
		case 0xf0f0f010://test
			fh=(u32)open("test.gba",O_BINARY | O_RDONLY,_S_IREAD | _S_IWRITE);
			len=read(fh,buf,1024*256);
			for(i=0;i<86112/4;i++){
				write_32bit(*((u32 *)buf+i));
			}
			break;
		case 0x5555aaaa:
			cmd=0;
			break;
		default:
			cmd=0;
			break;
		}
	}
}

#define	MODE_HOST	0
#define	MODE_RF		1
#define	MODE_WF		2
#define	MODE_RS		3
#define	MODE_WS		4
#define	MODE_EF		5
#define	MODE_AF		6

u8 agb_prog[]=
#include "agb_prog.h"

int	main( int argc, char *argv[] ){
	FILE *fp;
	s32 i,j,k;
	s32 mode;
	s32 len,dev_ofs,dev_len;
	s8	*endptr;
	s32 rom_type,rom_size,rom_blksize;
	s32 bu_type,bu_size,bu_blksize;
	s32 flen;
	u32 crc,crc2,ulen;

	printf("*********** BOOT CABLE CONSOLE TOOL Ver 3.54 ************\n");
	if(argc<2) goto USAGE;
	crc32_init();
	for(i=0;;i++){
		if(argv[1][i]==0) break;
		argv[1][i]=toupper(argv[1][i]);
	}
	if(strcmp(argv[1],"FR")==0){//tbVǂݍ
		mode=MODE_RF;
	}
	else if(strcmp(argv[1],"FW")==0){//tbV
		mode=MODE_WF;
	}
	else if(strcmp(argv[1],"FE")==0){//tbV
		mode=MODE_EF;
	}
	else if(strcmp(argv[1],"FA")==0){//tbVǋL
		mode=MODE_AF;
	}
	else if(strcmp(argv[1],"SR")==0){//SRAMǂݍ
		mode=MODE_RS;
	}
	else if(strcmp(argv[1],"SW")==0){//SRAM
		mode=MODE_WS;
	}
	else if(argc==2){
		mode=0;
		if((fp=fopen(argv[1],"rb"))==NULL){
			printf("Can't open %s file.\n",argv[1]);
			goto USAGE;
		}
		len=fread(buf,1,1024*256,fp);
		fclose(fp);
	}
	else{
		goto USAGE;
	}
	if(mode!=MODE_HOST){
		if(argc<2) goto USAGE;
#ifdef AGB_DEBUG
		if((fp=fopen("c:\\agb\\devkitadv\\wramloader\\fwlib.bin","rb"))==NULL){
			printf("Can't open fwlib.bin file.\n");
			exit(-1);
		}
		fread(buf,1,1024*32,fp);
		fclose(fp);
		if((fp=fopen("c:\\agb\\devkitadv\\fwbulib\\fwlib.bin","rb"))==NULL){
			printf("Can't open fwlib.bin file.\n");
			exit(-1);
		}
		len=1024*32+fread((u8 *)buf+1024*32,1,1024*32,fp);
		fclose(fp);
#else
		len=sizeof(agb_prog);
		memcpy(buf,agb_prog,len);
#endif
		if((mode==MODE_RF)||(mode==MODE_RS)){
			if((fp=fopen(argv[2],"wb"))==NULL){
				printf("Can't open %s file.\n",argv[2]);
				exit(-1);
			}
		}
		else if(mode!=MODE_EF){
			if((fp=fopen(argv[2],"rb"))==NULL){
				printf("Can't open %s file.\n",argv[2]);
				exit(-1);
			}
			fseek(fp,0,SEEK_END);
			flen=ftell(fp);
			fseek(fp,0,SEEK_SET);
		}
		dev_len=dev_ofs=-1;
		if(argc>4){
			if(memcmp(argv[3],"0x",2)==0){
				dev_ofs=strtoul(argv[3],&endptr,16);
			}
			else{
				dev_ofs=strtoul(argv[3],&endptr,10);
			}
			if(memcmp(argv[4],"0x",2)==0){
				dev_len=strtoul(argv[4],&endptr,16);
			}
			else{
				dev_len=strtoul(argv[4],&endptr,10);
			}
			if(toupper(*endptr)=='K'){
				dev_len*=1024;
			}
			else if(toupper(*endptr)=='M'){
				dev_len*=1024*1024;
			}
		}
	}
	dev_init();
	for(i=0;;i++){
		if(read_32bit()==0x5555aaaa) break;
		Sleep(1);
	}
	for(i=0;i<16;i++){
		write_32bit(0xffffffff);
	}
	write_32bit(0);
	write_32bit(len);
	for(i=0;i<(len+3)/4;i++){
		write_32bit(buf[i]);
	}
	if(mode!=MODE_HOST){
		Sleep(100);					//wait GBA is up
		write_32bit(CMD_BU_PROBE);	//cmd is 4 dwort
		write_32bit(0);
		write_32bit(0);
		write_32bit(0);
		for(;;){
			bu_type=read_32bit();
			if(bu_type!=0x5555aaaa) break;
			Sleep(1);
		}
		write_32bit(CMD_ROM_PROBE);	//cmd is 4 dwort
		write_32bit(0);
		write_32bit(0);
		write_32bit(0);
		for(;;){
			rom_type=read_32bit();
			if(rom_type!=0x5555aaaa) break;
			Sleep(1);
		}
		rom_size=read_32bit();
		rom_blksize=read_32bit();
		if(rom_type==1){
			printf("MASK ROM SIZE=0x%X\n",rom_size);
		}
		else if(rom_type!=0){
			printf("FLASH ROM SIZE=0x%X\n",rom_size);
		}
		write_32bit(CMD_IS_PRO);
		write_32bit(0);
		write_32bit(0);
		write_32bit(0);
		for(;;){
			is_pro=read_32bit();
			if(is_pro!=0x5555aaaa) break;
			Sleep(1);
		}

		bu_size=bu_blksize=0;
		switch(bu_type){
		case 1:
			bu_size=0x8000;
			bu_blksize=0x1000;
			printf("SRAM256K");
			break;
		case 2:
			if(is_pro==2){//ultra
				bu_size=0x40000*4;
				bu_blksize=0x1000;
				printf("SRAM8M");
			}
			else{
				bu_size=0x40000;
				bu_blksize=0x1000;
				printf("SRAM2M");
			}
			break;
		case 3:
			bu_size=0x10000;
			bu_blksize=0x1000;
			printf("FLASH512K");
			break;
		case 4:
			bu_size=0x200;
			bu_blksize=0x200;
			printf("EEP4K");
			break;
		case 5:
			bu_size=0x2000;
			bu_blksize=0x2000;
			printf("EEP64K");
			break;
		case 6:
			bu_size=0x20000;
			bu_blksize=0x1000;
			printf("FLASH1M");
			break;
		case 7:
			bu_size=0x100000-0x2000;
			bu_blksize=0x2000;
			printf("FLASH8M");
			break;
		}
		if(bu_type){
			printf(" SIZE=0x%X\n",bu_size);
		}
	}
	switch(mode){
	case MODE_HOST:
		host_proc();
		break;
	case MODE_RF:
		if(dev_len==-1) dev_len=rom_size;
		if(dev_ofs==-1) dev_ofs=0;
		printf("0x%X bytes reading.\n",dev_len);
		for(i=0;i<dev_len;){
			write_32bit(CMD_READ2);
			write_32bit(0x08000000+dev_ofs+i);
			write_32bit(0x1000);
			write_32bit(0);
			read_32bit();//dummy
			printf("R");
			for(j=0;j<0x1000/4;j++){
				buf[j]=read_32bit();
			}
			crc=crc32_calc((u8 *)buf,0x1000);
			for(;;){
				if(read_32bit()==FW_ACK) break;
				Sleep(1);
			}
			crc2=read_32bit();
			if(crc!=crc2) continue;
			if(dev_len-i>0x1000){
				j=0x1000;
			}
			else{
				j=dev_len-i;
			}
			fwrite(buf,1,j,fp);
			i+=0x1000;
		}
		break;
	case MODE_WF:
		if(dev_len==-1) dev_len=flen;
		if(dev_ofs==-1) dev_ofs=0;
		if(rom_size<dev_len){
			printf("Write size(0x%X) is too big.\n",dev_len);
			dev_len=rom_size;
		}
		if(dev_len>flen){
			printf("Write size is larger than file size.\n");
			dev_len=flen;
		}
		printf("0x%X bytes writeing.\n",dev_len);
		for(i=0;i<dev_len;){
			if(dev_len-i>0x1000){
				j=0x1000;
			}
			else{
				j=(dev_len-i+3)/4*4;
			}
			write_32bit(CMD_ROM_BWRITE);
			write_32bit(dev_ofs+i);
			write_32bit(j);
			write_32bit(0);
			printf("W");
			fread(buf,1,j,fp);
			for(k=0;k<j/4;k++){
				write_32bit(buf[k]);
			}
			crc=crc32_calc((u8 *)buf,j);
			for(;;){
				if(read_32bit()==FW_ACK) break;
				Sleep(1);
			}
			crc2=read_32bit();
			if(crc!=crc2) continue;
			i+=j;
		}
		write_32bit(CMD_BOOT_ROM);
		write_32bit(0);
		write_32bit(0);
		write_32bit(0);
		break;
	case MODE_AF:
		write_32bit(CMD_BLANK);
		write_32bit(0);
		write_32bit(0);
		write_32bit(0);
		for(;;){
			ulen=read_32bit();
			if(ulen!=0x5555aaaa) break;
			Sleep(1);
		}
		if(dev_len==-1) dev_len=flen;
		dev_ofs=rom_size-(ulen & 0xffff8000);
		if(dev_ofs!=0){
			if(is_pro==0){//PROłȂ
				if((dev_ofs & 0xffc08000)!=dev_ofs){
					dev_ofs=(dev_ofs+0x3fffff) & 0xffc00000;
				}
				dev_ofs |= 0x8000;
			}
		}
		if((rom_size-dev_ofs)<dev_len){
			printf("Write size(0x%X) is too big.\n",dev_len);
			dev_len=rom_size-dev_ofs;
		}
		printf("Start=0x%X  0x%X bytes writeing.\n",dev_ofs,dev_len);
		for(i=0;i<dev_len;){
			if(dev_len-i>0x1000){
				j=0x1000;
			}
			else{
				j=(dev_len-i+3)/4*4;
			}
			write_32bit(CMD_ROM_WRITE);
			write_32bit(dev_ofs+i);
			write_32bit(j);
			write_32bit(0);
			printf("W");
			fread(buf,1,j,fp);
			for(k=0;k<j/4;k++){
				write_32bit(buf[k]);
			}
			crc=crc32_calc((u8 *)buf,j);
			for(;;){
				if(read_32bit()==FW_ACK) break;
				Sleep(1);
			}
			crc2=read_32bit();
			if(crc!=crc2) continue;
			i+=j;
		}
		write_32bit(CMD_BOOT_ROM);
		write_32bit(0);
		write_32bit(0);
		write_32bit(0);
		break;
	case MODE_EF:
		printf("Erase START.\n");
		for(i=0;i<rom_size;i+=rom_blksize){
			write_32bit(CMD_ROM_BERASE);
			write_32bit(i);
			write_32bit(i);
			write_32bit(0);
			for(;;){
				if(read_32bit()==FW_ACK) break;
				Sleep(1);
			}
			printf("E");
		}
		printf("\nErase END.\n");
		exit(0);
		break;
	case MODE_RS:
		if(dev_len==-1) dev_len=bu_size;
		if(dev_ofs==-1) dev_ofs=0;
		if((dev_len & (bu_blksize-1))||(dev_ofs & (bu_blksize-1))){
			printf("SAVE read size and offset must be 0x%X boundary.\n",bu_blksize);
			exit(-1);
		}
		printf("0x%X bytes reading.\n",dev_len);
		for(i=0;i<dev_len;){
			if((bu_type==4)||(bu_type==5)){//EEP
				write_32bit(CMD_EEP_READ);
				write_32bit(dev_ofs+i);
				write_32bit(bu_blksize);
				write_32bit(0);
				Sleep(200);
				read_32bit();//dummy
			}
			else if(bu_type==7){
				write_32bit(CMD_READ);
				write_32bit(0x09f00000+dev_ofs+i);
				write_32bit(bu_blksize);
				write_32bit(0);
				read_32bit();//dummy
			}
			else{
				write_32bit(CMD_SRAM_READ);
				write_32bit(dev_ofs+i);
				write_32bit(bu_blksize);
				write_32bit(0);
				Sleep(30);
				read_32bit();//dummy
			}
			printf("R");
			for(j=0;j<bu_blksize/4;j++){
				buf[j]=read_32bit();
			}
			crc=crc32_calc((u8 *)buf,bu_blksize);
			for(;;){
				if(read_32bit()==FW_ACK) break;
				Sleep(1);
			}
			crc2=read_32bit();
			if(crc!=crc2) continue;
			fwrite(buf,1,bu_blksize,fp);
			i+=bu_blksize;
		}
		break;
	case MODE_WS:
		if(dev_ofs==-1) dev_ofs=0;
		if(dev_len==-1) dev_len=flen;
		if(dev_len>(bu_size-dev_ofs)){
			printf("Write size is longer than device.\n");
			dev_len=bu_size-dev_ofs;
		}
		if((dev_len & (bu_blksize-1))||(dev_ofs & (bu_blksize-1))){
			printf("SAVE read size and offset must be 0x%X boundary.\n",bu_blksize);
			exit(-1);
		}
		printf("0x%X bytes writeing.\n",dev_len);
		for(i=0;i<dev_len;){
			fread(buf,1,bu_blksize,fp);
			if((bu_type==4)||(bu_type==5)){//EEP
				write_32bit(CMD_EEP_WRITE);
				write_32bit(dev_ofs+i);
				write_32bit(bu_blksize);
				write_32bit(0);
			}
			else if((bu_type==1)||(bu_type==2)){//SRAM
				write_32bit(CMD_SRAM_WRITE);
				write_32bit(dev_ofs+i);
				write_32bit(bu_blksize);
				write_32bit(0);
			}
			else if((bu_type==3)||(bu_type==6)||(bu_type==7)){//FLASH
				write_32bit(CMD_FLASH_WRITE);
				write_32bit(dev_ofs+i);
				write_32bit(bu_blksize);
				write_32bit(0);
			}
			printf("W");
			for(j=0;j<bu_blksize/4;j++){
				write_32bit(buf[j]);
			}
			crc=crc32_calc((u8 *)buf,bu_blksize);
			for(;;){
				if(read_32bit()==FW_ACK) break;
				Sleep(1);
			}
			crc2=read_32bit();
			if(crc!=crc2) continue;
			i+=bu_blksize;
		}
		break;
	}
	if(mode!=MODE_HOST){
		fclose(fp);
	}
	exit(0);

USAGE:
	printf("FLASH READ ------- btcons fr file_name [start_offset len(?? ??k ??m)]\n");
	printf("FLASH WRITE ------ btcons fw file_name [start_offset len(?? ??k ??m)]\n");
	printf("FLASH APEND ------ btcons fa file_name\n");
	printf("FLASH ALL ERASE -- btcons fe\n");
	printf("SAVE READ -------- btcons sr file_name [start_offset len(?? ??k ??m)]\n");
	printf("SAVE WRITE ------- btcons sw file_name [start_offset len(?? ??k ??m)]\n");
	printf("PGM LOAD & GO ---- btcons pgm_file\n");
	exit(-1);
}
